Include qa/patch in Makefile
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         doc/users \
104         test/data/htools \
105         test/data/htools/rapi \
106         test/hs/shelltests \
107         test/autotools \
108         lib \
109         lib/build \
110         lib/client \
111         lib/cmdlib \
112         lib/confd \
113         lib/http \
114         lib/hypervisor \
115         lib/impexpd \
116         lib/masterd \
117         lib/rapi \
118         lib/server \
119         lib/tools \
120         lib/utils \
121         lib/watcher \
122         man \
123         qa \
124         qa/patch \
125         test \
126         test/data \
127         test/data/bdev-rbd \
128         test/data/ovfdata \
129         test/data/ovfdata/other \
130         test/py \
131         tools
132
133 ALL_APIDOC_HS_DIRS = \
134         $(APIDOC_HS_DIR) \
135         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
136
137 BUILDTIME_DIR_AUTOCREATE = \
138         scripts \
139         $(APIDOC_DIR) \
140         $(ALL_APIDOC_HS_DIRS) \
141         $(APIDOC_PY_DIR) \
142         $(COVERAGE_DIR) \
143         $(COVERAGE_HS_DIR) \
144         $(COVERAGE_PY_DIR) \
145         .hpc
146
147 BUILDTIME_DIRS = \
148         $(BUILDTIME_DIR_AUTOCREATE) \
149         doc/html \
150         doc/man-html
151
152 DIRCHECK_EXCLUDE = \
153         $(BUILDTIME_DIRS) \
154         ganeti-[0-9]*.[0-9]*.[0-9]* \
155         doc/html/_* \
156         doc/man-html/_* \
157         autom4te.cache
158
159 # some helper vars
160 COVERAGE_DIR = doc/coverage
161 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
162 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
163 APIDOC_DIR = doc/api
164 APIDOC_PY_DIR = $(APIDOC_DIR)/py
165 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
166
167 MAINTAINERCLEANFILES = \
168         $(maninput) \
169         doc/install-quick.rst \
170         doc/news.rst \
171         doc/upgrade.rst \
172         vcs-version
173
174 maintainer-clean-local:
175         rm -rf $(BUILDTIME_DIRS)
176
177 CLEANFILES = \
178         $(addsuffix /*.py[co],$(DIRS)) \
179         $(addsuffix /*.hi,$(HS_DIRS)) \
180         $(addsuffix /*.o,$(HS_DIRS)) \
181         $(PYTHON_BOOTSTRAP) \
182         epydoc.conf \
183         $(REPLACE_VARS_SED) \
184         $(SHELL_ENV_INIT) \
185         daemons/daemon-util \
186         daemons/ganeti-cleaner \
187         devel/squeeze-amd64.tar.gz \
188         devel/squeeze-amd64.conf \
189         $(mandocrst) \
190         doc/manpages-enabled.rst \
191         $(BUILT_EXAMPLES) \
192         doc/examples/bash_completion \
193         doc/examples/bash_completion-debug \
194         $(userspecs) \
195         lib/_generated_rpc.py \
196         $(man_MANS) \
197         $(manhtml) \
198         tools/kvm-ifup \
199         tools/users-setup \
200         tools/vcluster-setup \
201         stamp-directories \
202         stamp-srclinks \
203         $(nodist_pkgpython_PYTHON) \
204         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
205         $(HS_BUILT_TEST_HELPERS) \
206         src/ganeti-confd \
207         src/ganeti-luxid \
208         src/ganeti-mond \
209         .hpc/*.mix src/*.tix test/hs/*.tix \
210         doc/hs-lint.html
211
212 GENERATED_FILES = \
213         $(built_base_sources) \
214         $(BUILT_PYTHON_SOURCES) \
215         $(PYTHON_BOOTSTRAP)
216
217 HS_GENERATED_FILES =
218 if WANT_HTOOLS
219 HS_GENERATED_FILES += $(HS_PROGS)
220 if ENABLE_CONFD
221 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
222 endif
223
224 if ENABLE_MOND
225 HS_GENERATED_FILES += src/ganeti-mond
226 endif
227 endif
228
229 built_base_sources = \
230         stamp-directories \
231         stamp-srclinks
232
233 built_python_base_sources = \
234         lib/_autoconf.py \
235         lib/_vcsversion.py
236
237 BUILT_PYTHON_SOURCES = \
238         $(built_python_base_sources) \
239         lib/_generated_rpc.py
240
241 # Generating the RPC wrappers depends on many things, so make sure
242 # it's built at the end of the built sources
243 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
244
245 # these are all built from the underlying %.in sources
246 BUILT_EXAMPLES = \
247         doc/examples/ganeti-kvm-poweroff.initd \
248         doc/examples/ganeti.cron \
249         doc/examples/ganeti.initd \
250         doc/examples/ganeti.logrotate \
251         doc/examples/ganeti-master-role.ocf \
252         doc/examples/ganeti-node-role.ocf \
253         doc/examples/gnt-config-backup \
254         doc/examples/hooks/ipsec
255
256 nodist_pkgpython_PYTHON = \
257         $(BUILT_PYTHON_SOURCES)
258
259 noinst_PYTHON = \
260         lib/build/__init__.py \
261         lib/build/shell_example_lexer.py \
262         lib/build/sphinx_ext.py
263
264 pkgpython_PYTHON = \
265         lib/__init__.py \
266         lib/asyncnotifier.py \
267         lib/backend.py \
268         lib/bdev.py \
269         lib/bootstrap.py \
270         lib/cli.py \
271         lib/compat.py \
272         lib/config.py \
273         lib/constants.py \
274         lib/daemon.py \
275         lib/errors.py \
276         lib/hooksmaster.py \
277         lib/ht.py \
278         lib/jqueue.py \
279         lib/jstore.py \
280         lib/locking.py \
281         lib/luxi.py \
282         lib/mcpu.py \
283         lib/netutils.py \
284         lib/objects.py \
285         lib/opcodes.py \
286         lib/outils.py \
287         lib/ovf.py \
288         lib/pathutils.py \
289         lib/qlang.py \
290         lib/query.py \
291         lib/rpc.py \
292         lib/rpc_defs.py \
293         lib/runtime.py \
294         lib/serializer.py \
295         lib/ssconf.py \
296         lib/ssh.py \
297         lib/storage.py \
298         lib/uidpool.py \
299         lib/vcluster.py \
300         lib/network.py \
301         lib/workerpool.py
302
303 client_PYTHON = \
304         lib/client/__init__.py \
305         lib/client/gnt_backup.py \
306         lib/client/gnt_cluster.py \
307         lib/client/gnt_debug.py \
308         lib/client/gnt_group.py \
309         lib/client/gnt_instance.py \
310         lib/client/gnt_job.py \
311         lib/client/gnt_node.py \
312         lib/client/gnt_network.py \
313         lib/client/gnt_os.py \
314         lib/client/gnt_storage.py
315
316 cmdlib_PYTHON = \
317         lib/cmdlib/__init__.py \
318         lib/cmdlib/backup.py \
319         lib/cmdlib/base.py \
320         lib/cmdlib/cluster.py \
321         lib/cmdlib/common.py \
322         lib/cmdlib/group.py \
323         lib/cmdlib/instance.py \
324         lib/cmdlib/instance_migration.py \
325         lib/cmdlib/instance_operation.py \
326         lib/cmdlib/instance_query.py \
327         lib/cmdlib/instance_storage.py \
328         lib/cmdlib/instance_utils.py \
329         lib/cmdlib/misc.py \
330         lib/cmdlib/network.py \
331         lib/cmdlib/node.py \
332         lib/cmdlib/operating_system.py \
333         lib/cmdlib/query.py \
334         lib/cmdlib/tags.py \
335         lib/cmdlib/test.py
336
337 hypervisor_PYTHON = \
338         lib/hypervisor/__init__.py \
339         lib/hypervisor/hv_base.py \
340         lib/hypervisor/hv_chroot.py \
341         lib/hypervisor/hv_fake.py \
342         lib/hypervisor/hv_kvm.py \
343         lib/hypervisor/hv_lxc.py \
344         lib/hypervisor/hv_xen.py
345
346 rapi_PYTHON = \
347         lib/rapi/__init__.py \
348         lib/rapi/baserlib.py \
349         lib/rapi/client.py \
350         lib/rapi/client_utils.py \
351         lib/rapi/connector.py \
352         lib/rapi/rlib2.py \
353         lib/rapi/testutils.py
354
355 http_PYTHON = \
356         lib/http/__init__.py \
357         lib/http/auth.py \
358         lib/http/client.py \
359         lib/http/server.py
360
361 confd_PYTHON = \
362         lib/confd/__init__.py \
363         lib/confd/client.py
364
365 masterd_PYTHON = \
366         lib/masterd/__init__.py \
367         lib/masterd/iallocator.py \
368         lib/masterd/instance.py
369
370 impexpd_PYTHON = \
371         lib/impexpd/__init__.py
372
373 watcher_PYTHON = \
374         lib/watcher/__init__.py \
375         lib/watcher/nodemaint.py \
376         lib/watcher/state.py
377
378 server_PYTHON = \
379         lib/server/__init__.py \
380         lib/server/masterd.py \
381         lib/server/noded.py \
382         lib/server/rapi.py
383
384 pytools_PYTHON = \
385         lib/tools/__init__.py \
386         lib/tools/burnin.py \
387         lib/tools/ensure_dirs.py \
388         lib/tools/node_cleanup.py \
389         lib/tools/node_daemon_setup.py \
390         lib/tools/prepare_node_join.py
391
392 utils_PYTHON = \
393         lib/utils/__init__.py \
394         lib/utils/algo.py \
395         lib/utils/filelock.py \
396         lib/utils/hash.py \
397         lib/utils/io.py \
398         lib/utils/log.py \
399         lib/utils/lvm.py \
400         lib/utils/mlock.py \
401         lib/utils/nodesetup.py \
402         lib/utils/process.py \
403         lib/utils/retry.py \
404         lib/utils/text.py \
405         lib/utils/wrapper.py \
406         lib/utils/x509.py
407
408 docinput = \
409         doc/conf.py \
410         doc/css/style.css \
411         doc/admin.rst \
412         doc/cluster-merge.rst \
413         doc/design-2.0.rst \
414         doc/design-2.1.rst \
415         doc/design-2.2.rst \
416         doc/design-2.3.rst \
417         doc/design-2.4.rst \
418         doc/design-2.5.rst \
419         doc/design-2.6.rst \
420         doc/design-2.7.rst \
421         doc/design-2.8.rst \
422         doc/design-autorepair.rst \
423         doc/design-bulk-create.rst \
424         doc/design-chained-jobs.rst \
425         doc/design-cpu-pinning.rst \
426         doc/design-device-uuid-name.rst \
427         doc/design-draft.rst \
428         doc/design-daemons.rst \
429         doc/design-htools-2.3.rst \
430         doc/design-http-server.rst \
431         doc/design-impexp2.rst \
432         doc/design-lu-generated-jobs.rst \
433         doc/design-linuxha.rst \
434         doc/design-multi-reloc.rst \
435         doc/design-network.rst \
436         doc/design-node-add.rst \
437         doc/design-oob.rst \
438         doc/design-ovf-support.rst \
439         doc/design-opportunistic-locking.rst \
440         doc/design-partitioned.rst \
441         doc/design-query-splitting.rst \
442         doc/design-query2.rst \
443         doc/design-reason-trail.rst \
444         doc/design-resource-model.rst \
445         doc/design-restricted-commands.rst \
446         doc/design-shared-storage.rst \
447         doc/design-monitoring-agent.rst \
448         doc/design-virtual-clusters.rst \
449         doc/design-x509-ca.rst \
450         doc/design-hroller.rst \
451         doc/design-storagetypes.rst \
452         doc/devnotes.rst \
453         doc/glossary.rst \
454         doc/hooks.rst \
455         doc/iallocator.rst \
456         doc/index.rst \
457         doc/install-quick.rst \
458         doc/install.rst \
459         doc/locking.rst \
460         doc/manpages-disabled.rst \
461         doc/monitoring-query-format.rst \
462         doc/move-instance.rst \
463         doc/news.rst \
464         doc/ovfconverter.rst \
465         doc/rapi.rst \
466         doc/security.rst \
467         doc/upgrade.rst \
468         doc/virtual-cluster.rst \
469         doc/walkthrough.rst
470
471 # Generates file names such as "doc/man-gnt-instance.rst"
472 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
473
474 # Haskell programs to be installed in $PREFIX/bin
475 HS_BIN_PROGS=src/htools
476
477 # Haskell programs to be installed in the MYEXECLIB dir
478 if ENABLE_MOND
479 HS_MYEXECLIB_PROGS=src/mon-collector
480 else
481 HS_MYEXECLIB_PROGS=
482 endif
483
484 # Haskell programs to be compiled by "make really-all"
485 HS_COMPILE_PROGS= \
486         src/ganeti-mond \
487         src/hconfd \
488         src/hluxid \
489         src/rpc-test
490
491 # All Haskell non-test programs to be compiled but not automatically installed
492 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
493
494 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
495 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
496
497 HS_ALL_PROGS = \
498         $(HS_PROGS) \
499         test/hs/hpc-htools \
500         test/hs/hpc-mon-collector \
501         test/hs/htest \
502         $(HS_COMPILE_PROGS)
503
504 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
505 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
506
507 HFLAGS = \
508         -O -Wall -Werror -isrc \
509         -fwarn-monomorphism-restriction \
510         -fwarn-tabs \
511         $(GHC_BYVERSION_FLAGS)
512
513 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
514 HEXTRA =
515 # internal extra flags (used for test/hs/htest mainly)
516 HEXTRA_INT =
517 # exclude options for coverage reports
518 HPCEXCL = --exclude Main \
519         --exclude Ganeti.Constants \
520         --exclude Ganeti.HTools.QC \
521         --exclude Ganeti.THH \
522         --exclude Ganeti.Version \
523         --exclude Test.Ganeti.Attoparsec \
524         --exclude Test.Ganeti.TestCommon \
525         --exclude Test.Ganeti.TestHTools \
526         --exclude Test.Ganeti.TestHelper \
527         --exclude Test.Ganeti.TestImports \
528         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
529
530 HS_LIB_SRCS = \
531         src/Ganeti/Block/Drbd/Types.hs \
532         src/Ganeti/Block/Drbd/Parser.hs \
533         src/Ganeti/BasicTypes.hs \
534         src/Ganeti/Common.hs \
535         src/Ganeti/Compat.hs \
536         src/Ganeti/Confd/Client.hs \
537         src/Ganeti/Confd/Server.hs \
538         src/Ganeti/Confd/Types.hs \
539         src/Ganeti/Confd/Utils.hs \
540         src/Ganeti/Config.hs \
541         src/Ganeti/ConfigReader.hs \
542         src/Ganeti/Curl/Multi.hs \
543         src/Ganeti/Daemon.hs \
544         src/Ganeti/DataCollectors/CLI.hs \
545         src/Ganeti/DataCollectors/Drbd.hs \
546         src/Ganeti/DataCollectors/Program.hs \
547         src/Ganeti/DataCollectors/Types.hs \
548         src/Ganeti/Errors.hs \
549         src/Ganeti/HTools/Backend/IAlloc.hs \
550         src/Ganeti/HTools/Backend/Luxi.hs \
551         src/Ganeti/HTools/Backend/Rapi.hs \
552         src/Ganeti/HTools/Backend/Simu.hs \
553         src/Ganeti/HTools/Backend/Text.hs \
554         src/Ganeti/HTools/CLI.hs \
555         src/Ganeti/HTools/Cluster.hs \
556         src/Ganeti/HTools/Container.hs \
557         src/Ganeti/HTools/ExtLoader.hs \
558         src/Ganeti/HTools/Graph.hs \
559         src/Ganeti/HTools/Group.hs \
560         src/Ganeti/HTools/Instance.hs \
561         src/Ganeti/HTools/Loader.hs \
562         src/Ganeti/HTools/Nic.hs \
563         src/Ganeti/HTools/Node.hs \
564         src/Ganeti/HTools/PeerMap.hs \
565         src/Ganeti/HTools/Program/Hail.hs \
566         src/Ganeti/HTools/Program/Harep.hs \
567         src/Ganeti/HTools/Program/Hbal.hs \
568         src/Ganeti/HTools/Program/Hcheck.hs \
569         src/Ganeti/HTools/Program/Hinfo.hs \
570         src/Ganeti/HTools/Program/Hscan.hs \
571         src/Ganeti/HTools/Program/Hspace.hs \
572         src/Ganeti/HTools/Program/Hroller.hs \
573         src/Ganeti/HTools/Program/Main.hs \
574         src/Ganeti/HTools/Types.hs \
575         src/Ganeti/Hypervisor/Xen/XmParser.hs \
576         src/Ganeti/Hypervisor/Xen/Types.hs \
577         src/Ganeti/Hash.hs \
578         src/Ganeti/JQueue.hs \
579         src/Ganeti/JSON.hs \
580         src/Ganeti/Jobs.hs \
581         src/Ganeti/Logging.hs \
582         src/Ganeti/Luxi.hs \
583         src/Ganeti/Monitoring/Server.hs \
584         src/Ganeti/Network.hs \
585         src/Ganeti/Objects.hs \
586         src/Ganeti/OpCodes.hs \
587         src/Ganeti/OpParams.hs \
588         src/Ganeti/Path.hs \
589         src/Ganeti/Query/Common.hs \
590         src/Ganeti/Query/Export.hs \
591         src/Ganeti/Query/Filter.hs \
592         src/Ganeti/Query/Group.hs \
593         src/Ganeti/Query/Job.hs \
594         src/Ganeti/Query/Language.hs \
595         src/Ganeti/Query/Network.hs \
596         src/Ganeti/Query/Node.hs \
597         src/Ganeti/Query/Query.hs \
598         src/Ganeti/Query/Server.hs \
599         src/Ganeti/Query/Types.hs \
600         src/Ganeti/Rpc.hs \
601         src/Ganeti/Runtime.hs \
602         src/Ganeti/Ssconf.hs \
603         src/Ganeti/THH.hs \
604         src/Ganeti/Types.hs \
605         src/Ganeti/Utils.hs
606
607 HS_TEST_SRCS = \
608         test/hs/Test/Ganeti/Attoparsec.hs \
609         test/hs/Test/Ganeti/BasicTypes.hs \
610         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
611         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
612         test/hs/Test/Ganeti/Common.hs \
613         test/hs/Test/Ganeti/Confd/Types.hs \
614         test/hs/Test/Ganeti/Confd/Utils.hs \
615         test/hs/Test/Ganeti/Daemon.hs \
616         test/hs/Test/Ganeti/Errors.hs \
617         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
618         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
619         test/hs/Test/Ganeti/HTools/CLI.hs \
620         test/hs/Test/Ganeti/HTools/Cluster.hs \
621         test/hs/Test/Ganeti/HTools/Container.hs \
622         test/hs/Test/Ganeti/HTools/Graph.hs \
623         test/hs/Test/Ganeti/HTools/Instance.hs \
624         test/hs/Test/Ganeti/HTools/Loader.hs \
625         test/hs/Test/Ganeti/HTools/Node.hs \
626         test/hs/Test/Ganeti/HTools/PeerMap.hs \
627         test/hs/Test/Ganeti/HTools/Types.hs \
628         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
629         test/hs/Test/Ganeti/JSON.hs \
630         test/hs/Test/Ganeti/Jobs.hs \
631         test/hs/Test/Ganeti/JQueue.hs \
632         test/hs/Test/Ganeti/Luxi.hs \
633         test/hs/Test/Ganeti/Network.hs \
634         test/hs/Test/Ganeti/Objects.hs \
635         test/hs/Test/Ganeti/OpCodes.hs \
636         test/hs/Test/Ganeti/Query/Filter.hs \
637         test/hs/Test/Ganeti/Query/Language.hs \
638         test/hs/Test/Ganeti/Query/Network.hs \
639         test/hs/Test/Ganeti/Query/Query.hs \
640         test/hs/Test/Ganeti/Rpc.hs \
641         test/hs/Test/Ganeti/Runtime.hs \
642         test/hs/Test/Ganeti/Ssconf.hs \
643         test/hs/Test/Ganeti/THH.hs \
644         test/hs/Test/Ganeti/TestCommon.hs \
645         test/hs/Test/Ganeti/TestHTools.hs \
646         test/hs/Test/Ganeti/TestHelper.hs \
647         test/hs/Test/Ganeti/Types.hs \
648         test/hs/Test/Ganeti/Utils.hs
649
650 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
651
652 HS_BUILT_SRCS = \
653         test/hs/Test/Ganeti/TestImports.hs \
654         src/Ganeti/Constants.hs \
655         src/Ganeti/Curl/Internal.hs \
656         src/Ganeti/Version.hs
657 HS_BUILT_SRCS_IN = \
658         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
659         src/Ganeti/Curl/Internal.hsc
660
661 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
662
663 $(RUN_IN_TEMPDIR): | stamp-directories
664
665 doc/html/index.html: ENABLE_MANPAGES =
666 doc/man-html/index.html: ENABLE_MANPAGES = 1
667 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
668
669 # Note: we use here an order-only prerequisite, as the contents of
670 # _autoconf.py are not actually influencing the html build output: it
671 # has to exist in order for the sphinx module to be loaded
672 # successfully, but we certainly don't want the docs to be rebuilt if
673 # it changes
674 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
675         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
676         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
677         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
678         | $(BUILT_PYTHON_SOURCES)
679         @test -n "$(SPHINX)" || \
680             { echo 'sphinx-build' not found during configure; exit 1; }
681 if !MANPAGES_IN_DOC
682         if test -n '$(ENABLE_MANPAGES)'; then \
683           echo 'Man pages in documentation were disabled at configure time' >&2; \
684           exit 1; \
685         fi
686 endif
687 ## Sphinx provides little control over what content should be included. Some
688 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
689 ## build two different versions of the documentation--once without man pages and
690 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
691 ## us with this, but requires running in a temporary directory. It moves the
692 ## correct files into place depending on environment variables.
693         dir=$(dir $@) && \
694         @mkdir_p@ $$dir && \
695         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
696         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
697             -d . \
698             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
699             -D release="$(PACKAGE_VERSION)" \
700             -D graphviz_dot="$(DOT)" \
701             -D enable_manpages="$(ENABLE_MANPAGES)" \
702             doc $(CURDIR)/$$dir && \
703         rm -f $$dir/.buildinfo $$dir/objects.inv
704         touch $@
705
706 doc/html: doc/html/index.html
707
708 doc/man-html: doc/man-html/index.html
709
710 doc/install-quick.rst: INSTALL
711 doc/news.rst: NEWS
712 doc/upgrade.rst: UPGRADE
713
714 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
715         set -e; \
716         { echo '.. This file is automatically updated at build time from $<.'; \
717           echo '.. Do not edit.'; \
718           echo; \
719           cat $<; \
720         } > $@
721
722 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
723         { echo '.. This file is automatically generated, do not edit!'; \
724           echo ''; \
725           echo 'Man pages'; \
726           echo '========='; \
727           echo; \
728           echo '.. toctree::'; \
729           echo '   :maxdepth: 1'; \
730           echo; \
731           for i in $(notdir $(mandocrst)); do \
732             echo "   $$i"; \
733           done | LC_ALL=C sort; \
734         } > $@
735
736 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
737 if MANPAGES_IN_DOC
738         { echo '.. This file is automatically updated at build time from $<.'; \
739           echo '.. Do not edit.'; \
740           echo; \
741           echo "$*"; \
742           echo '=========================================='; \
743           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
744         } > $@
745 else
746         echo 'Man pages in documentation were disabled at configure time' >&2; \
747         exit 1;
748 endif
749
750 doc/users/%: doc/users/%.in Makefile $(REPLACE_VARS_SED)
751         cat $< | sed -f $(REPLACE_VARS_SED) | LC_ALL=C sort | uniq | (grep -v '^root' || true) > $@
752
753 userspecs = \
754         doc/users/users \
755         doc/users/groups \
756         doc/users/groupmemberships
757
758 # Things to build but not to install (add it to EXTRA_DIST if it should be
759 # distributed)
760 noinst_DATA = \
761         $(BUILT_EXAMPLES) \
762         doc/examples/bash_completion \
763         doc/examples/bash_completion-debug \
764         $(userspecs) \
765         $(manhtml)
766
767 if HAS_SPHINX
768 if MANPAGES_IN_DOC
769 noinst_DATA += doc/man-html
770 else
771 noinst_DATA += doc/html
772 endif
773 endif
774
775 gnt_scripts = \
776         scripts/gnt-backup \
777         scripts/gnt-cluster \
778         scripts/gnt-debug \
779         scripts/gnt-group \
780         scripts/gnt-instance \
781         scripts/gnt-job \
782         scripts/gnt-network \
783         scripts/gnt-node \
784         scripts/gnt-os \
785         scripts/gnt-storage
786
787 PYTHON_BOOTSTRAP_SBIN = \
788         daemons/ganeti-masterd \
789         daemons/ganeti-noded \
790         daemons/ganeti-rapi \
791         daemons/ganeti-watcher \
792         $(gnt_scripts)
793
794 PYTHON_BOOTSTRAP = \
795         $(PYTHON_BOOTSTRAP_SBIN) \
796         tools/burnin \
797         tools/ensure-dirs \
798         tools/node-cleanup \
799         tools/node-daemon-setup \
800         tools/prepare-node-join
801
802 qa_scripts = \
803         qa/__init__.py \
804         qa/ganeti-qa.py \
805         qa/qa_cluster.py \
806         qa/qa_config.py \
807         qa/qa_daemon.py \
808         qa/qa_env.py \
809         qa/qa_error.py \
810         qa/qa_group.py \
811         qa/qa_instance.py \
812         qa/qa_job.py \
813   qa/qa_logging.py \
814         qa/qa_node.py \
815         qa/qa_os.py \
816         qa/qa_rapi.py \
817         qa/qa_tags.py \
818         qa/qa_utils.py
819
820 bin_SCRIPTS =
821 if WANT_HTOOLS
822 bin_SCRIPTS += $(HS_BIN_PROGS)
823 install-exec-hook:
824         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
825 # FIXME: this is a hardcoded logic, instead of auto-resolving
826         $(LN_S) -f ../../../bin/htools \
827           $(DESTDIR)$(iallocatorsdir)/hail
828         for role in $(HS_BIN_ROLES); do \
829           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
830         done
831 endif
832
833 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
834         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
835           echo "Error: cannot run unittests without the development" \
836                " libraries (see devnotes.rst)" 1>&2; \
837           exit 1; \
838         fi
839         @rm -f $(notdir $@).tix
840         $(GHC) --make \
841           $(HFLAGS) \
842           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
843           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
844           $(HEXTRA) $(HEXTRA_INT) $@
845         @touch "$@"
846
847 # for the test/hs/htest binary, we need to enable profiling/coverage
848 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
849
850 # we compile the hpc-htools binary with the program coverage
851 test/hs/hpc-htools: HEXTRA_INT=-fhpc
852
853 # we compile the hpc-mon-collector binary with the program coverage
854 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
855
856 # test dependency
857 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
858
859 # rules for building profiling-enabled versions of the haskell
860 # programs: hs-prof does the full two-step build, whereas
861 # hs-prof-quick does only the final rebuild (hs-prof must have been
862 # run before)
863 .PHONY: hs-prof hs-prof-quick
864 hs-prof:
865         @if [ -z "$(TARGET)" ]; then \
866           echo "You need to define TARGET when running this rule" 1>&2; \
867           exit 1; \
868         fi
869         $(MAKE) $(AM_MAKEFLAGS) clean
870         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
871         rm -f $(HS_ALL_PROGS)
872         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
873
874 hs-prof-quick:
875         @if [ -z "$(TARGET)" ]; then \
876           echo "You need to define TARGET when running this rule" 1>&2; \
877           exit 1; \
878         fi
879         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
880
881 dist_sbin_SCRIPTS = \
882         tools/ganeti-listrunner
883
884 nodist_sbin_SCRIPTS = \
885         $(PYTHON_BOOTSTRAP_SBIN) \
886         daemons/ganeti-cleaner
887
888 if ENABLE_CONFD
889 src/ganeti-confd: src/hconfd
890         cp -f $< $@
891
892 src/ganeti-luxid: src/hluxid
893         cp -f $< $@
894
895 nodist_sbin_SCRIPTS += src/ganeti-confd
896 nodist_sbin_SCRIPTS += src/ganeti-luxid
897 endif
898
899 if ENABLE_MOND
900 nodist_sbin_SCRIPTS += src/ganeti-mond
901 endif
902
903 python_scripts = \
904         tools/cfgshell \
905         tools/cfgupgrade \
906         tools/cfgupgrade12 \
907         tools/cluster-merge \
908         tools/confd-client \
909         tools/fmtjson \
910         tools/lvmstrap \
911         tools/move-instance \
912         tools/ovfconverter \
913         tools/sanitize-config
914
915 dist_tools_SCRIPTS = \
916         $(python_scripts) \
917         tools/burnin \
918         tools/kvm-console-wrapper \
919         tools/master-ip-setup \
920         tools/xen-console-wrapper
921
922 nodist_tools_python_scripts = \
923         tools/node-cleanup
924
925 nodist_tools_SCRIPTS = \
926         $(nodist_tools_python_scripts) \
927         tools/users-setup \
928         tools/vcluster-setup
929
930 pkglib_python_scripts = \
931         daemons/import-export \
932         tools/check-cert-expired
933
934 nodist_pkglib_python_scripts = \
935         tools/ensure-dirs \
936         tools/node-daemon-setup \
937         tools/prepare-node-join
938
939 myexeclib_SCRIPTS = \
940         daemons/daemon-util \
941         tools/kvm-ifup \
942         $(pkglib_python_scripts) \
943         $(HS_MYEXECLIB_PROGS)
944
945 nodist_myexeclib_SCRIPTS = \
946         $(nodist_pkglib_python_scripts)
947
948 EXTRA_DIST = \
949         NEWS \
950         UPGRADE \
951         epydoc.conf.in \
952         pylintrc \
953         autotools/build-bash-completion \
954         autotools/build-rpc \
955         autotools/check-header \
956         autotools/check-imports \
957         autotools/check-man-dashes \
958         autotools/check-man-references \
959         autotools/check-man-warnings \
960         autotools/check-news \
961         autotools/check-python-code \
962         autotools/check-tar \
963         autotools/check-version \
964         autotools/convert-constants \
965         autotools/docpp \
966         autotools/gen-py-coverage \
967         autotools/sphinx-wrapper \
968         autotools/testrunner \
969         autotools/wrong-hardcoded-paths \
970         $(RUN_IN_TEMPDIR) \
971         daemons/daemon-util.in \
972         daemons/ganeti-cleaner.in \
973         $(pkglib_python_scripts) \
974         devel/upload \
975         devel/webserver \
976         tools/kvm-ifup.in \
977         tools/vcluster-setup.in \
978         $(docinput) \
979         doc/html \
980         $(BUILT_EXAMPLES:%=%.in) \
981         doc/examples/ganeti.default \
982         doc/examples/ganeti.default-debug \
983         doc/examples/hooks/ethers \
984         doc/examples/gnt-debug/README \
985         doc/examples/gnt-debug/delay0.json \
986         doc/examples/gnt-debug/delay50.json \
987         doc/users/groupmemberships.in \
988         doc/users/groups.in \
989         doc/users/users.in \
990         test/py/lockperf.py \
991         test/py/testutils.py \
992         test/py/mocks.py \
993         $(dist_TESTS) \
994         $(TEST_FILES) \
995         man/footer.rst \
996         $(manrst) \
997         $(maninput) \
998         qa/qa-sample.json \
999         $(qa_scripts) \
1000         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1001         $(HS_PROG_SRCS) \
1002         src/lint-hints.hs \
1003         test/hs/cli-tests-defs.sh \
1004         test/hs/offline-test.sh \
1005         .ghci
1006
1007 man_MANS = \
1008         man/ganeti-cleaner.8 \
1009         man/ganeti-confd.8 \
1010         man/ganeti-luxid.8 \
1011         man/ganeti-listrunner.8 \
1012         man/ganeti-masterd.8 \
1013         man/ganeti-mond.8 \
1014         man/ganeti-noded.8 \
1015         man/ganeti-os-interface.7 \
1016         man/ganeti-extstorage-interface.7 \
1017         man/ganeti-rapi.8 \
1018         man/ganeti-watcher.8 \
1019         man/ganeti.7 \
1020         man/gnt-backup.8 \
1021         man/gnt-cluster.8 \
1022         man/gnt-debug.8 \
1023         man/gnt-group.8 \
1024         man/gnt-network.8 \
1025         man/gnt-instance.8 \
1026         man/gnt-job.8 \
1027         man/gnt-node.8 \
1028         man/gnt-os.8 \
1029         man/gnt-storage.8 \
1030         man/hail.1 \
1031         man/harep.1 \
1032         man/hbal.1 \
1033         man/hcheck.1 \
1034         man/hinfo.1 \
1035         man/hscan.1 \
1036         man/hspace.1 \
1037         man/hroller.1 \
1038         man/htools.1 \
1039         man/mon-collector.7
1040
1041 # Remove extensions from all filenames in man_MANS
1042 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1043
1044 manrst = $(patsubst %,%.rst,$(mannoext))
1045 manhtml = $(patsubst %.rst,%.html,$(manrst))
1046 mangen = $(patsubst %.rst,%.gen,$(manrst))
1047 maninput = \
1048         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1049         $(patsubst %.html,%.html.in,$(manhtml)) \
1050         $(mangen)
1051
1052 TEST_FILES = \
1053         test/autotools/autotools-check-news.test \
1054         test/data/htools/clean-nonzero-score.data \
1055         test/data/htools/common-suffix.data \
1056         test/data/htools/empty-cluster.data \
1057         test/data/htools/hail-alloc-drbd.json \
1058         test/data/htools/hail-alloc-invalid-network.json \
1059         test/data/htools/hail-alloc-invalid-twodisks.json \
1060         test/data/htools/hail-alloc-restricted-network.json \
1061         test/data/htools/hail-alloc-twodisks.json \
1062         test/data/htools/hail-change-group.json \
1063         test/data/htools/hail-invalid-reloc.json \
1064         test/data/htools/hail-node-evac.json \
1065         test/data/htools/hail-reloc-drbd.json \
1066         test/data/htools/hbal-excl-tags.data \
1067         test/data/htools/hbal-split-insts.data \
1068         test/data/htools/hspace-tiered-dualspec.data \
1069         test/data/htools/hspace-tiered-ipolicy.data \
1070         test/data/htools/hspace-tiered-resourcetypes.data \
1071         test/data/htools/hspace-tiered.data \
1072         test/data/htools/invalid-node.data \
1073         test/data/htools/missing-resources.data \
1074         test/data/htools/multiple-master.data \
1075         test/data/htools/n1-failure.data \
1076         test/data/htools/rapi/groups.json \
1077         test/data/htools/rapi/info.json \
1078         test/data/htools/rapi/instances.json \
1079         test/data/htools/rapi/nodes.json \
1080         test/data/htools/unique-reboot-order.data \
1081         test/hs/shelltests/htools-balancing.test \
1082         test/hs/shelltests/htools-basic.test \
1083         test/hs/shelltests/htools-dynutil.test \
1084         test/hs/shelltests/htools-excl.test \
1085         test/hs/shelltests/htools-hail.test \
1086         test/hs/shelltests/htools-hroller.test \
1087         test/hs/shelltests/htools-hspace.test \
1088         test/hs/shelltests/htools-invalid.test \
1089         test/hs/shelltests/htools-multi-group.test \
1090         test/hs/shelltests/htools-no-backend.test \
1091         test/hs/shelltests/htools-rapi.test \
1092         test/hs/shelltests/htools-single-group.test \
1093         test/hs/shelltests/htools-text-backend.test \
1094         test/hs/shelltests/htools-mon-collector.test \
1095         test/data/bdev-drbd-8.0.txt \
1096         test/data/bdev-drbd-8.3.txt \
1097         test/data/bdev-drbd-disk.txt \
1098         test/data/bdev-drbd-net-ip4.txt \
1099         test/data/bdev-drbd-net-ip6.txt \
1100         test/data/bdev-rbd/json_output_empty.txt \
1101         test/data/bdev-rbd/json_output_extra_matches.txt \
1102         test/data/bdev-rbd/json_output_no_matches.txt \
1103         test/data/bdev-rbd/json_output_ok.txt \
1104         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1105         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1106         test/data/bdev-rbd/plain_output_new_ok.txt \
1107         test/data/bdev-rbd/plain_output_old_empty.txt \
1108         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1109         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1110         test/data/bdev-rbd/plain_output_old_ok.txt \
1111         test/data/bdev-rbd/output_invalid.txt \
1112         test/data/cert1.pem \
1113         test/data/cert2.pem \
1114         test/data/cluster_config_2.7.json \
1115         test/data/cluster_config_downgraded_2.7.json \
1116         test/data/instance-minor-pairing.txt \
1117         test/data/ip-addr-show-dummy0.txt \
1118         test/data/ip-addr-show-lo-ipv4.txt \
1119         test/data/ip-addr-show-lo-ipv6.txt \
1120         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1121         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1122         test/data/ip-addr-show-lo-oneline.txt \
1123         test/data/ip-addr-show-lo.txt \
1124         test/data/kvm_0.12.5_help.txt \
1125         test/data/kvm_0.15.90_help.txt \
1126         test/data/kvm_0.9.1_help.txt \
1127         test/data/kvm_0.9.1_help_boot_test.txt \
1128         test/data/kvm_1.0_help.txt \
1129         test/data/kvm_1.1.2_help.txt \
1130         test/data/NEWS_OK.txt \
1131         test/data/NEWS_previous_unreleased.txt \
1132         test/data/ovfdata/compr_disk.vmdk.gz \
1133         test/data/ovfdata/config.ini \
1134         test/data/ovfdata/corrupted_resources.ovf \
1135         test/data/ovfdata/empty.ini \
1136         test/data/ovfdata/empty.ovf \
1137         test/data/ovfdata/ganeti.mf \
1138         test/data/ovfdata/ganeti.ovf \
1139         test/data/ovfdata/gzip_disk.ovf \
1140         test/data/ovfdata/new_disk.vmdk \
1141         test/data/ovfdata/no_disk.ini \
1142         test/data/ovfdata/no_disk_in_ref.ovf \
1143         test/data/ovfdata/no_os.ini \
1144         test/data/ovfdata/no_ovf.ova \
1145         test/data/ovfdata/other/rawdisk.raw \
1146         test/data/ovfdata/ova.ova \
1147         test/data/ovfdata/rawdisk.raw \
1148         test/data/ovfdata/second_disk.vmdk \
1149         test/data/ovfdata/unsafe_path.ini \
1150         test/data/ovfdata/virtualbox.ovf \
1151         test/data/ovfdata/wrong_config.ini \
1152         test/data/ovfdata/wrong_extension.ovd \
1153         test/data/ovfdata/wrong_manifest.mf \
1154         test/data/ovfdata/wrong_manifest.ovf \
1155         test/data/ovfdata/wrong_ova.ova \
1156         test/data/ovfdata/wrong_xml.ovf \
1157         test/data/proc_drbd8.txt \
1158         test/data/proc_drbd80-emptyline.txt \
1159         test/data/proc_drbd83.txt \
1160         test/data/proc_drbd83_sync.txt \
1161         test/data/proc_drbd83_sync_want.txt \
1162         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1163         test/data/proc_meminfo.txt \
1164         test/data/proc_cpuinfo.txt \
1165         test/data/qa-minimal-nodes-instances-only.json \
1166         test/data/sys_drbd_usermode_helper.txt \
1167         test/data/vgreduce-removemissing-2.02.02.txt \
1168         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1169         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1170         test/data/vgs-missing-pvs-2.02.02.txt \
1171         test/data/vgs-missing-pvs-2.02.66.txt \
1172         test/data/xen-xm-info-4.0.1.txt \
1173         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1174         test/data/xen-xm-list-4.0.1-four-instances.txt \
1175         test/data/xen-xm-list-long-4.0.1.txt \
1176         test/data/xen-xm-uptime-4.0.1.txt \
1177         test/py/ganeti-cli.test \
1178         test/py/gnt-cli.test \
1179         test/py/import-export_unittest-helper
1180
1181
1182 python_tests = \
1183         doc/examples/rapi_testutils.py \
1184         test/py/cfgupgrade_unittest.py \
1185         test/py/docs_unittest.py \
1186         test/py/ganeti.asyncnotifier_unittest.py \
1187         test/py/ganeti.backend_unittest-runasroot.py \
1188         test/py/ganeti.backend_unittest.py \
1189         test/py/ganeti.bdev_unittest.py \
1190         test/py/ganeti.cli_unittest.py \
1191         test/py/ganeti.client.gnt_cluster_unittest.py \
1192         test/py/ganeti.client.gnt_instance_unittest.py \
1193         test/py/ganeti.client.gnt_job_unittest.py \
1194         test/py/ganeti.cmdlib_unittest.py \
1195         test/py/ganeti.compat_unittest.py \
1196         test/py/ganeti.confd.client_unittest.py \
1197         test/py/ganeti.config_unittest.py \
1198         test/py/ganeti.constants_unittest.py \
1199         test/py/ganeti.daemon_unittest.py \
1200         test/py/ganeti.errors_unittest.py \
1201         test/py/ganeti.hooks_unittest.py \
1202         test/py/ganeti.ht_unittest.py \
1203         test/py/ganeti.http_unittest.py \
1204         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1205         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1206         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1207         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1208         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1209         test/py/ganeti.hypervisor_unittest.py \
1210         test/py/ganeti.impexpd_unittest.py \
1211         test/py/ganeti.jqueue_unittest.py \
1212         test/py/ganeti.jstore_unittest.py \
1213         test/py/ganeti.locking_unittest.py \
1214         test/py/ganeti.luxi_unittest.py \
1215         test/py/ganeti.masterd.iallocator_unittest.py \
1216         test/py/ganeti.masterd.instance_unittest.py \
1217         test/py/ganeti.mcpu_unittest.py \
1218         test/py/ganeti.netutils_unittest.py \
1219         test/py/ganeti.objects_unittest.py \
1220         test/py/ganeti.opcodes_unittest.py \
1221         test/py/ganeti.outils_unittest.py \
1222         test/py/ganeti.ovf_unittest.py \
1223         test/py/ganeti.qlang_unittest.py \
1224         test/py/ganeti.query_unittest.py \
1225         test/py/ganeti.rapi.baserlib_unittest.py \
1226         test/py/ganeti.rapi.client_unittest.py \
1227         test/py/ganeti.rapi.resources_unittest.py \
1228         test/py/ganeti.rapi.rlib2_unittest.py \
1229         test/py/ganeti.rapi.testutils_unittest.py \
1230         test/py/ganeti.rpc_unittest.py \
1231         test/py/ganeti.runtime_unittest.py \
1232         test/py/ganeti.serializer_unittest.py \
1233         test/py/ganeti.server.rapi_unittest.py \
1234         test/py/ganeti.ssconf_unittest.py \
1235         test/py/ganeti.ssh_unittest.py \
1236         test/py/ganeti.storage_unittest.py \
1237         test/py/ganeti.tools.burnin_unittest.py \
1238         test/py/ganeti.tools.ensure_dirs_unittest.py \
1239         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1240         test/py/ganeti.tools.prepare_node_join_unittest.py \
1241         test/py/ganeti.uidpool_unittest.py \
1242         test/py/ganeti.utils.algo_unittest.py \
1243         test/py/ganeti.utils.filelock_unittest.py \
1244         test/py/ganeti.utils.hash_unittest.py \
1245         test/py/ganeti.utils.io_unittest-runasroot.py \
1246         test/py/ganeti.utils.io_unittest.py \
1247         test/py/ganeti.utils.log_unittest.py \
1248         test/py/ganeti.utils.lvm_unittest.py \
1249         test/py/ganeti.utils.mlock_unittest.py \
1250         test/py/ganeti.utils.nodesetup_unittest.py \
1251         test/py/ganeti.utils.process_unittest.py \
1252         test/py/ganeti.utils.retry_unittest.py \
1253         test/py/ganeti.utils.text_unittest.py \
1254         test/py/ganeti.utils.wrapper_unittest.py \
1255         test/py/ganeti.utils.x509_unittest.py \
1256         test/py/ganeti.utils_unittest.py \
1257         test/py/ganeti.vcluster_unittest.py \
1258         test/py/ganeti.workerpool_unittest.py \
1259         test/py/pycurl_reset_unittest.py \
1260         test/py/qa.qa_config_unittest.py \
1261         test/py/tempfile_fork_unittest.py
1262
1263 haskell_tests = test/hs/htest
1264
1265 dist_TESTS = \
1266         test/py/check-cert-expired_unittest.bash \
1267         test/py/daemon-util_unittest.bash \
1268         test/py/ganeti-cleaner_unittest.bash \
1269         test/py/import-export_unittest.bash \
1270         test/py/cli-test.bash \
1271         test/py/bash_completion.bash
1272
1273 if PY_UNIT
1274 dist_TESTS += $(python_tests)
1275 endif
1276
1277 nodist_TESTS =
1278 check_SCRIPTS =
1279
1280 if WANT_HSTESTS
1281 nodist_TESTS += $(haskell_tests)
1282 dist_TESTS += test/hs/offline-test.sh
1283 check_SCRIPTS += \
1284         test/hs/hpc-htools \
1285         test/hs/hpc-mon-collector \
1286         $(HS_BUILT_TEST_HELPERS)
1287 endif
1288
1289 TESTS = $(dist_TESTS) $(nodist_TESTS)
1290
1291 # Environment for all tests
1292 PLAIN_TESTS_ENVIRONMENT = \
1293         PYTHONPATH=. \
1294         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1295         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1296         $(RUN_IN_TEMPDIR)
1297
1298 # Environment for tests run by automake
1299 TESTS_ENVIRONMENT = \
1300         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1301
1302 all_python_code = \
1303         $(dist_sbin_SCRIPTS) \
1304         $(python_scripts) \
1305         $(pkglib_python_scripts) \
1306         $(nodist_pkglib_python_scripts) \
1307         $(nodist_tools_python_scripts) \
1308         $(pkgpython_PYTHON) \
1309         $(client_PYTHON) \
1310         $(cmdlib_PYTHON) \
1311         $(hypervisor_PYTHON) \
1312         $(rapi_PYTHON) \
1313         $(server_PYTHON) \
1314         $(pytools_PYTHON) \
1315         $(http_PYTHON) \
1316         $(confd_PYTHON) \
1317         $(masterd_PYTHON) \
1318         $(impexpd_PYTHON) \
1319         $(utils_PYTHON) \
1320         $(watcher_PYTHON) \
1321         $(noinst_PYTHON) \
1322         $(qa_scripts)
1323
1324 if PY_UNIT
1325 all_python_code += $(python_tests)
1326 endif
1327
1328 srclink_files = \
1329         man/footer.rst \
1330         test/py/check-cert-expired_unittest.bash \
1331         test/py/daemon-util_unittest.bash \
1332         test/py/ganeti-cleaner_unittest.bash \
1333         test/py/import-export_unittest.bash \
1334         test/py/cli-test.bash \
1335         test/py/bash_completion.bash \
1336         test/hs/offline-test.sh \
1337         test/hs/cli-tests-defs.sh \
1338         $(all_python_code) \
1339         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1340         $(docinput)
1341
1342 check_python_code = \
1343         $(BUILD_BASH_COMPLETION) \
1344         $(CHECK_IMPORTS) \
1345         $(CHECK_HEADER) \
1346         $(DOCPP) \
1347         $(all_python_code)
1348
1349 lint_python_code = \
1350         ganeti \
1351         ganeti/http/server.py \
1352         $(dist_sbin_SCRIPTS) \
1353         $(python_scripts) \
1354         $(pkglib_python_scripts) \
1355         $(BUILD_BASH_COMPLETION) \
1356         $(CHECK_IMPORTS) \
1357         $(CHECK_HEADER) \
1358         $(DOCPP) \
1359         $(PYTHON_BOOTSTRAP)
1360
1361 standalone_python_modules = \
1362         lib/rapi/client.py \
1363         tools/ganeti-listrunner
1364
1365 pep8_python_code = \
1366         ganeti \
1367         ganeti/http/server.py \
1368         $(dist_sbin_SCRIPTS) \
1369         $(python_scripts) \
1370         $(pkglib_python_scripts) \
1371         $(BUILD_BASH_COMPLETION) \
1372         $(CHECK_HEADER) \
1373         $(DOCPP) \
1374         $(PYTHON_BOOTSTRAP) \
1375         qa
1376
1377 test/py/daemon-util_unittest.bash: daemons/daemon-util
1378
1379 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1380
1381 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1382
1383 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1384         sed -f $(REPLACE_VARS_SED) < $< > $@
1385         chmod +x $@
1386
1387 tools/users-setup: Makefile $(userspecs)
1388         set -e; \
1389         { echo '#!/bin/sh'; \
1390           echo 'if [ "x$$1" != "x--yes-do-it" ];'; \
1391           echo 'then echo "This will do the following changes"'; \
1392           $(AWK) -- '{print "echo + Will add group ",$$1; count++}\
1393                      END {if (count == 0) {print "echo + No groups to add"}}' doc/users/groups; \
1394           $(AWK) -- '{if (NF > 1) {print "echo + Will add user",$$1,"with primary group",$$2} \
1395                                   else {print "echo + Will add user",$$1}; count++}\
1396                      END {if (count == 0) {print "echo + No users to add"}}' doc/users/users; \
1397           $(AWK) -- '{print "echo + Will add user",$$1,"to group",$$2}' doc/users/groupmemberships; \
1398           echo 'echo'; \
1399           echo 'echo "OK? (y/n)"'; \
1400           echo 'read confirm'; \
1401           echo 'if [ "x$$confirm" != "xy" ]; then exit 0; fi'; \
1402           echo 'fi'; \
1403           $(AWK) -- '{print "addgroup --system",$$1}' doc/users/groups; \
1404           $(AWK) -- '{if (NF > 1) {print "adduser --system --ingroup",$$2,$$1} else {print "adduser --system",$$1}}' doc/users/users; \
1405           $(AWK) -- '{print "adduser",$$1,$$2}' doc/users/groupmemberships; \
1406         } > $@
1407         chmod +x $@
1408
1409 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1410         sed -f $(REPLACE_VARS_SED) < $< > $@
1411         chmod +x $@
1412
1413 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1414         sed -f $(REPLACE_VARS_SED) < $< > $@
1415         chmod +x $@
1416
1417 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1418         sed -f $(REPLACE_VARS_SED) < $< > $@
1419
1420 doc/examples/bash_completion: BC_ARGS = --compact
1421 doc/examples/bash_completion-debug: BC_ARGS =
1422
1423 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1424         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1425         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1426         daemons/ganeti-cleaner \
1427         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1428         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1429           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1430
1431 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1432         lib/build/shell_example_lexer.py \
1433         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1434         @echo "Checking $< for hardcoded paths..."
1435         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1436           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1437           exit 1; \
1438         fi
1439         set -e ; \
1440         trap 'echo auto-removing $@; rm $@' EXIT; \
1441         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1442         $(CHECK_MAN_REFERENCES) $@; \
1443         trap - EXIT
1444
1445 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1446         @test -n "$(PANDOC)" || \
1447           { echo 'pandoc' not found during configure; exit 1; }
1448         set -o pipefail -e; \
1449         trap 'echo auto-removing $@; rm $@' EXIT; \
1450         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1451           sed -e 's/\\@/@/g' > $@; \
1452         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1453         $(CHECK_MAN_DASHES) $@; \
1454         trap - EXIT
1455
1456 man/%.html.in: man/%.gen man/footer.rst
1457         @test -n "$(PANDOC)" || \
1458           { echo 'pandoc' not found during configure; exit 1; }
1459         set -o pipefail ; \
1460         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1461           sed -e 's/\\@/@/g' > $@
1462
1463 man/%: man/%.in  $(REPLACE_VARS_SED)
1464         sed -f $(REPLACE_VARS_SED) < $< > $@
1465
1466 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1467         sed -f $(REPLACE_VARS_SED) < $< > $@
1468
1469 vcs-version:
1470         if test -d .git; then \
1471           git describe > $@; \
1472         elif test ! -f $@ ; then \
1473           echo "Cannot auto-generate $@ file"; exit 1; \
1474         fi
1475
1476 .PHONY: clean-vcs-version
1477 clean-vcs-version:
1478         rm -f vcs-version
1479
1480 .PHONY: regen-vcs-version
1481 regen-vcs-version:
1482         @set -e; \
1483         cd $(srcdir); \
1484         if test -d .git; then \
1485           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1486           git describe > $$T; \
1487           if ! cmp --quiet $$T vcs-version; then \
1488             mv $$T vcs-version; \
1489           fi; \
1490         fi
1491
1492 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1493         vcs-version $(built_base_sources)
1494         set -e; \
1495         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1496         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1497
1498 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1499         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1500         lib/jstore.py $(RUN_IN_TEMPDIR) \
1501         $(CONVERT_CONSTANTS) $(built_base_sources) \
1502         | lib/_vcsversion.py
1503         set -e; \
1504         { cat $< ; \
1505           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1506         } > $@
1507
1508 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1509         hsc2hs -o $@ $<
1510
1511 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1512         $(built_base_sources)
1513         set -e; \
1514         { cat $< ; \
1515           echo ; \
1516           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1517             echo "import $$name ()" ; \
1518           done ; \
1519         } > $@
1520
1521 lib/_autoconf.py: Makefile | stamp-directories
1522         set -e; \
1523         { echo '# This file is automatically generated, do not edit!'; \
1524           echo '#'; \
1525           echo ''; \
1526           echo '"""Build-time configuration for Ganeti.'; \
1527           echo '';\
1528           echo 'This file is autogenerated by the build process.'; \
1529           echo 'For any changes you need to re-run ./configure (and'; \
1530           echo 'not edit by hand).'; \
1531           echo ''; \
1532           echo '"""'; \
1533           echo ''; \
1534           echo '# pylint: disable=C0301,C0324'; \
1535           echo '# because this is autogenerated, we do not want'; \
1536           echo '# style warnings' ; \
1537           echo ''; \
1538           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1539           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1540           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1541           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1542           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1543           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1544           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1545           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1546           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1547           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1548           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1549           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1550           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1551           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1552           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1553           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1554           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1555           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1556           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1557           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1558           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1559           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1560           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1561           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1562           echo "KVM_PATH = '$(KVM_PATH)'"; \
1563           echo "IP_PATH = '$(IP_PATH)'"; \
1564           echo "SOCAT_PATH = '$(SOCAT)'"; \
1565           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1566           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1567           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1568           echo "TOOLSDIR = '$(toolsdir)'"; \
1569           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1570           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1571           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1572           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1573           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1574           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1575           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1576           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1577           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1578           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1579           echo "RAPI_USER = '$(RAPI_USER)'"; \
1580           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1581           echo "CONFD_USER = '$(CONFD_USER)'"; \
1582           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1583           echo "LUXID_USER = '$(LUXID_USER)'"; \
1584           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1585           echo "NODED_USER = '$(NODED_USER)'"; \
1586           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1587           echo "MOND_USER = '$(MOND_USER)'"; \
1588           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1589           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1590           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1591           echo "HTOOLS = True"; \
1592           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1593           echo "XEN_CMD = '$(XEN_CMD)'"; \
1594           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1595           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1596           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1597 ## Write dictionary with man page name as the key and the section number as the
1598 ## value
1599           echo "MAN_PAGES = {"; \
1600           for i in $(notdir $(man_MANS)); do \
1601             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1602           done; \
1603           echo "}"; \
1604         } > $@
1605
1606 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1607         set -e; \
1608         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1609         { echo '# This file is automatically generated, do not edit!'; \
1610           echo '#'; \
1611           echo ''; \
1612           echo '"""Build-time VCS version number for Ganeti.'; \
1613           echo '';\
1614           echo 'This file is autogenerated by the build process.'; \
1615           echo 'For any changes you need to re-run ./configure (and'; \
1616           echo 'not edit by hand).'; \
1617           echo ''; \
1618           echo '"""'; \
1619           echo ''; \
1620           echo '# pylint: disable=C0301,C0324'; \
1621           echo '# because this is autogenerated, we do not want'; \
1622           echo '# style warnings' ; \
1623           echo ''; \
1624           echo "VCS_VERSION = '$$VCSVER'"; \
1625         } > $@
1626
1627 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1628         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1629
1630 $(SHELL_ENV_INIT): Makefile stamp-directories
1631         set -e; \
1632         { echo '# Allow overriding for tests'; \
1633           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1634           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1635           echo; \
1636           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1637           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1638           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1639           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1640           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1641         } > $@
1642
1643 ## Writes sed script to replace placeholders with build-time values. The
1644 ## additional quotes after the first @ sign are necessary to stop configure
1645 ## from replacing those values as well.
1646 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1647         set -e; \
1648         { echo 's#@''PREFIX@#$(prefix)#g'; \
1649           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1650           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1651           echo 's#@''BINDIR@#$(bindir)#g'; \
1652           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1653           echo 's#@''LIBDIR@#$(libdir)#g'; \
1654           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1655           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1656           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1657           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1658           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1659           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1660           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1661           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1662           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1663           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1664           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1665           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1666           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1667           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1668           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1669           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1670           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1671           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1672           echo 's#@''GNTNODEDGROUP@#$(NODED_GROUP)#g'; \
1673           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1674           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1675           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1676           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1677           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1678           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1679           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1680           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1681           echo; \
1682           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1683           echo '  r $(SHELL_ENV_INIT)'; \
1684           echo '  d'; \
1685           echo '}'; \
1686         } > $@
1687
1688 # Using deferred evaluation
1689 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1690 daemons/ganeti-watcher: MODULE = ganeti.watcher
1691 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1692 tools/burnin: MODULE = ganeti.tools.burnin
1693 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1694 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1695 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1696 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1697 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1698
1699 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1700         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1701         set -e; \
1702         { echo '#!/usr/bin/python'; \
1703           echo '# This file is automatically generated, do not edit!'; \
1704           echo "# Edit $(MODULE) instead."; \
1705           echo; \
1706           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1707           echo; \
1708           echo '# pylint: disable=C0103'; \
1709           echo '# C0103: Invalid name'; \
1710           echo; \
1711           echo 'import sys'; \
1712           echo 'import $(MODULE) as main'; \
1713           echo; \
1714           echo '# Temporarily alias commands until bash completion'; \
1715           echo '# generator is changed'; \
1716           echo 'if hasattr(main, "commands"):'; \
1717           echo '  commands = main.commands # pylint: disable=E1101'; \
1718           echo 'if hasattr(main, "aliases"):'; \
1719           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1720           echo; \
1721           echo 'if __name__ == "__main__":'; \
1722           echo '  sys.exit(main.Main())'; \
1723         } > $@
1724         chmod u+x $@
1725
1726 $(HS_BUILT_TEST_HELPERS): Makefile
1727         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1728         set -e; \
1729         { echo '#!/bin/sh'; \
1730           echo '# This file is automatically generated, do not edit!'; \
1731           echo "# Edit Makefile.am instead."; \
1732           echo; \
1733           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1734         } > $@
1735         chmod u+x $@
1736
1737 stamp-directories: Makefile
1738         $(MAKE) $(AM_MAKEFLAGS) ganeti
1739         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1740         touch $@
1741
1742 # We need to create symlinks because "make distcheck" will not install Python
1743 # files when building.
1744 stamp-srclinks: Makefile | stamp-directories
1745         set -e; \
1746         for i in $(srclink_files); do \
1747           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1748             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1749           fi; \
1750         done
1751         touch $@
1752
1753 .PHONY: ganeti
1754 ganeti:
1755         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1756
1757 .PHONY: check-dirs
1758 check-dirs: $(GENERATED_FILES)
1759         @set -e; \
1760         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1761           error=; \
1762           while read dir; do \
1763             case "$$dir" in \
1764               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1765               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1766             esac; \
1767           done; \
1768           for dir in $(DIRS); do \
1769             if ! test -d "$$dir"; then \
1770               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1771               error=1; \
1772             fi \
1773           done; \
1774           test -z "$$error"; \
1775         }
1776
1777 .PHONY: check-local
1778 check-local: check-dirs $(GENERATED_FILES)
1779         $(CHECK_PYTHON_CODE) $(check_python_code)
1780         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1781         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1782         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1783         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1784         error= ; \
1785         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1786           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1787           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1788             echo "Incorrect version in README, expected $$expver" >&2; \
1789             error=1; \
1790           fi; \
1791           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1792               doc/security.rst; do \
1793             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1794               "Documents Ganeti version $$expver"; then \
1795               echo "Incorrect version in $$file, expected $$expver" >&2; \
1796               error=1; \
1797             fi; \
1798           done; \
1799           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1800             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1801             error=1; \
1802           fi; \
1803           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1804             ".. Last updated for Ganeti $$expver"; then \
1805             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1806             error=1; \
1807           fi; \
1808         fi; \
1809         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1810           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1811             echo "Longest line in $$file is longer than 80 characters" >&2; \
1812             error=1; \
1813           fi; \
1814         done; \
1815         test -z "$$error"
1816
1817 .PHONY: hs-tests
1818 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1819         @rm -f htest.tix
1820         ./test/hs/htest
1821
1822 .PHONY: hs-shell
1823 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1824         @rm -f hpc-htools.tix hpc-mon-collector.tix
1825         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1826
1827 .PHONY: hs-check
1828 hs-check: hs-tests hs-shell
1829
1830 # E111: indentation is not a multiple of four
1831 # E121: continuation line indentation is not a multiple of four
1832 #       (since our indent level is not 4)
1833 # E125: continuation line does not distinguish itself from next logical line
1834 #       (since our indent level is not 4)
1835 # E127: continuation line over-indented for visual indent
1836 #       (since our indent level is not 4)
1837 # note: do NOT add E128 here; it's a valid style error in most cases!
1838 # I've seen real errors, but also some cases were we indent wrongly
1839 # due to line length; try to rework the cases where it is triggered,
1840 # instead of silencing it
1841 # E261: at least two spaces before inline comment
1842 # E501: line too long (80 characters)
1843 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1844
1845 # For excluding pep8 expects filenames only, not whole paths
1846 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1847
1848 LINT_TARGETS = pylint pylint-qa
1849 if HAS_PEP8
1850 LINT_TARGETS += pep8
1851 endif
1852 if HAS_HLINT
1853 LINT_TARGETS += hlint
1854 endif
1855
1856 .PHONY: lint
1857 lint: $(LINT_TARGETS)
1858
1859 .PHONY: pylint
1860 pylint: $(GENERATED_FILES)
1861         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1862         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1863
1864 .PHONY: pylint-qa
1865 pylint-qa: $(GENERATED_FILES)
1866         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1867         cd $(top_srcdir)/qa && \
1868           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1869           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1870
1871 .PHONY: pep8
1872 pep8: $(GENERATED_FILES)
1873         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1874         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1875           --repeat $(pep8_python_code)
1876
1877 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1878 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1879 .PHONY: hlint
1880 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1881         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1882         @rm -f doc/hs-lint.html
1883         if tty -s; then C="-c"; else C=""; fi; \
1884         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1885           --ignore "Use first" \
1886           --ignore "Use &&&" \
1887           --ignore "Use void" \
1888           --ignore "Reduce duplication" \
1889           --hint src/lint-hints \
1890           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1891         @if [ ! -f doc/hs-lint.html ]; then \
1892           echo "All good" > doc/hs-lint.html; \
1893         fi
1894
1895 # a dist hook rule for updating the vcs-version file; this is
1896 # hardcoded due to where it needs to build the file...
1897 dist-hook:
1898         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1899         rm -f $(top_distdir)/vcs-version
1900         cp -p $(srcdir)/vcs-version $(top_distdir)
1901
1902 # a distcheck hook rule for catching revision control directories
1903 distcheck-hook:
1904         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1905           echo "Found revision control files in final archive." 1>&2; \
1906           exit 1; \
1907         fi
1908         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1909           echo "Found Python byte code in final archive." 1>&2; \
1910           exit 1; \
1911         fi
1912         if find $(top_distdir) -name '*~' | grep .; then \
1913           echo "Found backup files in final archive." 1>&2; \
1914           exit 1; \
1915         fi
1916 # Empty files or directories should not be distributed. They can cause
1917 # unnecessary warnings for packagers. Directories used by automake during
1918 # distcheck must be excluded.
1919         if find $(top_distdir) -empty -and -not \( \
1920             -path $(top_distdir)/_build -or \
1921             -path $(top_distdir)/_inst \) | grep .; then \
1922           echo "Found empty files or directories in final archive." 1>&2; \
1923           exit 1; \
1924         fi
1925         if test -e $(top_distdir)/doc/man-html; then \
1926           echo "Found documentation including man pages in final archive" >&2; \
1927           exit 1; \
1928         fi
1929
1930 # Backwards compatible distcheck-release target
1931 distcheck-release: distcheck
1932
1933 distrebuildcheck: dist
1934         set -e; \
1935         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1936         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1937         cd $$builddir; \
1938         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1939         cd $(distdir); \
1940         ./configure; \
1941         $(MAKE) maintainer-clean; \
1942         cp $(abs_srcdir)/vcs-version .; \
1943         ./configure; \
1944         $(MAKE) $(AM_MAKEFLAGS)
1945
1946 dist-release: dist
1947         set -e; \
1948         for i in $(DIST_ARCHIVES); do \
1949           echo -n "Checking $$i ... "; \
1950           autotools/check-tar < $$i; \
1951           echo OK; \
1952         done
1953
1954 install-exec-local:
1955         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1956           "$(DESTDIR)${localstatedir}/log/ganeti" \
1957           "$(DESTDIR)${localstatedir}/run/ganeti"
1958
1959 .PHONY: apidoc
1960 if WANT_HSAPIDOC
1961 apidoc: py-apidoc hs-apidoc
1962 else
1963 apidoc: py-apidoc
1964 endif
1965
1966 .PHONY: py-apidoc
1967 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1968         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1969         $(RUN_IN_TEMPDIR) epydoc -v \
1970           --conf $(CURDIR)/epydoc.conf \
1971           --output $(CURDIR)/$(APIDOC_PY_DIR)
1972
1973 .PHONY: hs-apidoc
1974 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1975
1976 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1977         @test -n "$(HSCOLOUR)" || \
1978             { echo 'HsColour' not found during configure; exit 1; }
1979         @test -n "$(HADDOCK)" || \
1980             { echo 'haddock' not found during configure; exit 1; }
1981         rm -rf $(APIDOC_HS_DIR)/*
1982         for i in $(ALL_APIDOC_HS_DIRS); do \
1983           @mkdir_p@ $$i; \
1984           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1985         done
1986         set -e ; \
1987         export LC_ALL=en_US.UTF-8; \
1988         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1989         if [ "$(HS_PARALLEL3)" ]; \
1990         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1991         fi; \
1992         if [ "$(HS_REGEX_PCRE)" ]; \
1993         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1994         fi; \
1995         for file in $(HS_LIBTESTBUILT_SRCS); do \
1996           f_nosrc=$${file##src/}; \
1997           f_notst=$${f_nosrc##test/hs/}; \
1998           f_html=$${f_notst%%.hs}.html; \
1999           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2000         done ; \
2001         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2002           -t ganeti -p src/haddock-prologue \
2003           --source-module="%{MODULE/.//}.html" \
2004           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2005           $$OPTGHC \
2006           $(HS_LIBTESTBUILT_SRCS)
2007
2008 .PHONY: TAGS
2009 TAGS: $(GENERATED_FILES)
2010         rm -f TAGS
2011         $(GHC) -e ":etags" -v0 \
2012           $(filter-out -O -Werror,$(HFLAGS)) \
2013           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2014           $(HS_LIBTEST_SRCS)
2015         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2016           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2017           -path './qa/*.py' | \
2018           etags -l python -a -
2019
2020 .PHONY: coverage
2021
2022 COVERAGE_TESTS=
2023 if WANT_HTOOLS
2024 COVERAGE_TESTS += hs-coverage
2025 endif
2026 if PY_UNIT
2027 COVERAGE_TESTS += py-coverage
2028 endif
2029
2030 coverage: $(COVERAGE_TESTS)
2031
2032 .PHONY: py-coverage
2033 py-coverage: $(GENERATED_FILES) $(python_tests)
2034         @test -n "$(PYCOVERAGE)" || \
2035             { echo 'python-coverage' not found during configure; exit 1; }
2036         set -e; \
2037         COVERAGE=$(PYCOVERAGE) \
2038         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2039         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2040         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2041         $(PLAIN_TESTS_ENVIRONMENT) \
2042         $(abs_top_srcdir)/autotools/gen-py-coverage \
2043         $(python_tests)
2044
2045 .PHONY: hs-coverage
2046 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2047         rm -f *.tix
2048         $(MAKE) $(AM_MAKEFLAGS) hs-check
2049         @mkdir_p@ $(COVERAGE_HS_DIR)
2050         hpc sum --union $(HPCEXCL) \
2051           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2052         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2053         hpc report coverage-hs.tix
2054         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2055
2056 # Special "kind-of-QA" target for htools, needs special setup (all
2057 # tools compiled with -fhpc)
2058 .PHONY: live-test
2059 live-test: all
2060         set -e ; \
2061         cd src; \
2062         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2063         rm -f *.tix *.mix; \
2064         ./live-test.sh; \
2065         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2066           --output=live-test.tix ; \
2067         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2068         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2069           --srcdir=.. $(HPCEXCL) ; \
2070         hpc report --srcdir=.. live-test $(HPCEXCL)
2071
2072 commit-check: autotools-check distcheck lint apidoc
2073
2074 autotools-check:
2075         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2076   $(abs_top_srcdir)/test/autotools/*-*.test \
2077   -- --hide-successes
2078
2079 .PHONY: gitignore-check
2080 gitignore-check:
2081         @if [ -n "`git status --short`" ]; then \
2082           echo "Git status is not clean!" 1>&2 ; \
2083           git status --short; \
2084           exit 1; \
2085         fi
2086
2087 # target to rebuild all man pages (both groff and html output)
2088 .PHONY: man
2089 man: $(man_MANS) $(manhtml)
2090
2091 # Target that builds all binaries (including those that are not
2092 # rebuilt except when running the tests)
2093 .PHONY: really-all
2094 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2095
2096 # we don't need the ancient implicit rules:
2097 %: %,v
2098 %: RCS/%,v
2099 %: RCS/%
2100 %: s.%
2101 %: SCCS/s.%
2102
2103 -include ./Makefile.local
2104
2105 # vim: set noet :